Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 43666)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 43678)
@@ -2048,6 +2048,16 @@
 {
     UIProxyManager proxyManager(settings().proxySettings());
+    if (proxyManager.authEnabled())
+    {
+        proxyManager.setAuthEnabled(false);
+        proxyManager.setAuthLogin(QString());
+        proxyManager.setAuthPassword(QString());
+        VBoxGlobalSettings globalSettings = settings();
+        globalSettings.setProxySettings(proxyManager.toString());
+        vboxGlobal().setSettings(globalSettings);
+    }
     if (proxyManager.proxyEnabled())
     {
+#if 0
         QNetworkProxy::setApplicationProxy(QNetworkProxy(QNetworkProxy::HttpProxy,
                                                          proxyManager.proxyHost(),
@@ -2055,4 +2065,9 @@
                                                          proxyManager.authEnabled() ? proxyManager.authLogin() : QString(),
                                                          proxyManager.authEnabled() ? proxyManager.authPassword() : QString()));
+#else
+        QNetworkProxy::setApplicationProxy(QNetworkProxy(QNetworkProxy::HttpProxy,
+                                                         proxyManager.proxyHost(),
+                                                         proxyManager.proxyPort().toInt()));
+#endif
     }
     else
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.cpp	(revision 43666)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.cpp	(revision 43678)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2011-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -37,10 +37,21 @@
     m_pHostEditor->setValidator(new QRegExpValidator(QRegExp("\\S+"), m_pHostEditor));
     m_pPortEditor->setValidator(new QRegExpValidator(QRegExp("\\d+"), m_pPortEditor));
+#if 0
     m_pLoginEditor->setValidator(new QRegExpValidator(QRegExp("\\S+"), m_pLoginEditor));
     m_pPasswordEditor->setValidator(new QRegExpValidator(QRegExp("\\S+"), m_pPasswordEditor));
+#else
+    m_pLoginLabel->hide();
+    m_pLoginEditor->hide();
+    m_pPasswordLabel->hide();
+    m_pPasswordEditor->hide();
+#endif
 
     /* Setup connections: */
     connect(m_pProxyCheckbox, SIGNAL(stateChanged(int)), this, SLOT(sltProxyToggled()));
+#if 0
     connect(m_pAuthCheckbox, SIGNAL(stateChanged(int)), this, SLOT(sltAuthToggled()));
+#else
+    m_pAuthCheckbox->hide();
+#endif
 
     /* Apply language settings: */
@@ -60,7 +71,9 @@
     m_cache.m_strProxyHost = proxyManager.proxyHost();
     m_cache.m_strProxyPort = proxyManager.proxyPort();
+#if 0
     m_cache.m_fAuthEnabled = proxyManager.authEnabled();
     m_cache.m_strAuthLogin = proxyManager.authLogin();
     m_cache.m_strAuthPassword = proxyManager.authPassword();
+#endif
 
     /* Upload properties & settings to data: */
@@ -76,7 +89,9 @@
     m_pHostEditor->setText(m_cache.m_strProxyHost);
     m_pPortEditor->setText(m_cache.m_strProxyPort);
+#if 0
     m_pAuthCheckbox->setChecked(m_cache.m_fAuthEnabled);
     m_pLoginEditor->setText(m_cache.m_strAuthLogin);
     m_pPasswordEditor->setText(m_cache.m_strAuthPassword);
+#endif
     sltProxyToggled();
 }
@@ -90,7 +105,9 @@
     m_cache.m_strProxyHost = m_pHostEditor->text();
     m_cache.m_strProxyPort = m_pPortEditor->text();
+#if 0
     m_cache.m_fAuthEnabled = m_pAuthCheckbox->isChecked();
     m_cache.m_strAuthLogin = m_pLoginEditor->text();
     m_cache.m_strAuthPassword = m_pPasswordEditor->text();
+#endif
 }
 
@@ -106,7 +123,9 @@
     proxyManager.setProxyHost(m_cache.m_strProxyHost);
     proxyManager.setProxyPort(m_cache.m_strProxyPort);
+#if 0
     proxyManager.setAuthEnabled(m_cache.m_fAuthEnabled);
     proxyManager.setAuthLogin(m_cache.m_strAuthLogin);
     proxyManager.setAuthPassword(m_cache.m_strAuthPassword);
+#endif
     m_settings.setProxySettings(proxyManager.toString());
 
@@ -127,7 +146,9 @@
     setTabOrder(m_pProxyCheckbox, m_pHostEditor);
     setTabOrder(m_pHostEditor, m_pPortEditor);
+#if 0
     setTabOrder(m_pPortEditor, m_pAuthCheckbox);
     setTabOrder(m_pAuthCheckbox, m_pLoginEditor);
     setTabOrder(m_pLoginEditor, m_pPasswordEditor);
+#endif
 }
 
@@ -146,10 +167,13 @@
     m_pPortLabel->setEnabled(m_pProxyCheckbox->isChecked());
     m_pPortEditor->setEnabled(m_pProxyCheckbox->isChecked());
+#if 0
     m_pAuthCheckbox->setEnabled(m_pProxyCheckbox->isChecked());
 
     /* Update auth widgets also: */
     sltAuthToggled();
+#endif
 }
 
+#if 0
 void UIGlobalSettingsProxy::sltAuthToggled()
 {
@@ -164,3 +188,4 @@
         m_pValidator->revalidate();
 }
+#endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.h	(revision 43666)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.h	(revision 43678)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2011-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -27,11 +27,18 @@
 struct UISettingsCacheGlobalProxy
 {
-    UISettingsCacheGlobalProxy() : m_fProxyEnabled(false), m_fAuthEnabled(false) {}
+    UISettingsCacheGlobalProxy()
+        : m_fProxyEnabled(false)
+#if 0
+        , m_fAuthEnabled(false)
+#endif
+    {}
     bool m_fProxyEnabled;
     QString m_strProxyHost;
     QString m_strProxyPort;
+#if 0
     bool m_fAuthEnabled;
     QString m_strAuthLogin;
     QString m_strAuthPassword;
+#endif
 };
 
@@ -74,5 +81,7 @@
 
     void sltProxyToggled();
+#if 0
     void sltAuthToggled();
+#endif
 
 private: