Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserHandlerKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserHandlerKeyboard.cpp	(revision 43777)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserHandlerKeyboard.cpp	(revision 43778)
@@ -333,7 +333,7 @@
                     /* Toggle that group: */
                     UIGChooserItemGroup *pGroupItem = pFocusItem->toGroupItem();
-                    if (pGroupItem->closed())
+                    if (pGroupItem->isClosed())
                         pGroupItem->open();
-                    else
+                    else if (pGroupItem->isOpened())
                         pGroupItem->close();
                     /* Filter that event out: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserHandlerMouse.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserHandlerMouse.cpp	(revision 43777)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserHandlerMouse.cpp	(revision 43778)
@@ -186,8 +186,8 @@
                         {
                             /* Toggle it: */
-                            if (pGroupItem->opened())
+                            if (pGroupItem->isClosed())
+                                pGroupItem->open();
+                            else if (pGroupItem->isOpened())
                                 pGroupItem->close();
-                            else if (pGroupItem->closed())
-                                pGroupItem->open();
                         }
                         /* If click was at right part: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.cpp	(revision 43777)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.cpp	(revision 43778)
@@ -171,5 +171,5 @@
             pParentItem->makeSureItsVisible();
             /* And make sure its opened: */
-            if (pParentItem->closed())
+            if (pParentItem->isClosed())
                 pParentItem->open(false);
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.cpp	(revision 43777)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.cpp	(revision 43778)
@@ -60,5 +60,5 @@
     : UIGChooserItem(0, true /* temporary? */)
     , m_strName(pCopyFrom->name())
-    , m_fClosed(pCopyFrom->closed())
+    , m_fClosed(pCopyFrom->isClosed())
     , m_fMainRoot(fMainRoot)
 {
@@ -105,5 +105,5 @@
     : UIGChooserItem(pParent, pParent->isTemporary())
     , m_strName(pCopyFrom->name())
-    , m_fClosed(pCopyFrom->closed())
+    , m_fClosed(pCopyFrom->isClosed())
     , m_fMainRoot(false)
 {
@@ -182,10 +182,10 @@
 }
 
-bool UIGChooserItemGroup::closed() const
+bool UIGChooserItemGroup::isClosed() const
 {
     return m_fClosed && !isRoot();
 }
 
-bool UIGChooserItemGroup::opened() const
+bool UIGChooserItemGroup::isOpened() const
 {
     return !m_fClosed || isRoot();
@@ -503,5 +503,5 @@
     {
         /* Setup toggle-button: */
-        m_pToggleButton = new UIGraphicsRotatorButton(this, "additionalHeight", opened());
+        m_pToggleButton = new UIGraphicsRotatorButton(this, "additionalHeight", isOpened());
         connect(m_pToggleButton, SIGNAL(sigRotationStart()), this, SLOT(sltGroupToggleStart()));
         connect(m_pToggleButton, SIGNAL(sigRotationFinish(bool)), this, SLOT(sltGroupToggleFinish(bool)));
@@ -563,5 +563,5 @@
     UIGChooserItem::show();
     /* Show children: */
-    if (!closed())
+    if (!isClosed())
         foreach (UIGChooserItem *pItem, items())
             pItem->show();
@@ -946,5 +946,5 @@
 
     /* No body for closed group: */
-    if (closed())
+    if (isClosed())
     {
         /* Hide all the items: */
@@ -1053,10 +1053,10 @@
 int UIGChooserItemGroup::minimumWidthHint() const
 {
-    return minimumWidthHint(closed());
+    return minimumWidthHint(isClosed());
 }
 
 int UIGChooserItemGroup::minimumHeightHint() const
 {
-    return minimumHeightHint(closed());
+    return minimumHeightHint(isClosed());
 }
 
@@ -1070,5 +1070,5 @@
     /* If Qt::MinimumSize requested: */
     if (which == Qt::MinimumSize)
-        return minimumSizeHint(closed());
+        return minimumSizeHint(isClosed());
     /* Else call to base-class: */
     return UIGChooserItem::sizeHint(which, constraint);
@@ -1082,5 +1082,5 @@
 
     /* Update toggle-button tool-tip: */
-    m_pToggleButton->setToolTip(opened() ? tr("Collapse group") : tr("Expand group"));
+    m_pToggleButton->setToolTip(isOpened() ? tr("Collapse group") : tr("Expand group"));
 }
 
@@ -1196,5 +1196,5 @@
                 /* Copy passed item into this group: */
                 UIGChooserItem *pNewGroupItem = new UIGChooserItemGroup(this, pItem->toGroupItem(), iPosition);
-                if (closed())
+                if (isClosed())
                     open(false);
 
@@ -1249,5 +1249,5 @@
                 /* Copy passed machine-item into this group: */
                 UIGChooserItem *pNewMachineItem = new UIGChooserItemMachine(this, pItem->toMachineItem(), iPosition);
-                if (closed())
+                if (isClosed())
                     open(false);
 
@@ -1308,5 +1308,5 @@
 void UIGChooserItemGroup::paint(QPainter *pPainter, const QStyleOptionGraphicsItem *pOption, QWidget* /* pWidget = 0 */)
 {
-    paint(pPainter, pOption, closed());
+    paint(pPainter, pOption, isClosed());
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.h	(revision 43777)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.h	(revision 43778)
@@ -72,6 +72,6 @@
     QString definition() const;
     void setName(const QString &strName);
-    bool closed() const;
-    bool opened() const;
+    bool isClosed() const;
+    bool isOpened() const;
     void close(bool fAnimated = true);
     void open(bool fAnimated = true);
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 43777)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 43778)
@@ -1348,5 +1348,5 @@
     {
         navigationItems << pGroupItem;
-        if (pGroupItem->toGroupItem()->opened())
+        if (pGroupItem->toGroupItem()->isOpened())
             navigationItems << createNavigationList(pGroupItem);
     }
@@ -1691,5 +1691,5 @@
                 UIGChooserItem *pFoundItem = getGroupItem(strFirstSuffix, pGroupItem, fAllGroupsOpened);
                 if (UIGChooserItemGroup *pFoundGroupItem = pFoundItem->toGroupItem())
-                    if (fAllGroupsOpened && pFoundGroupItem->closed())
+                    if (fAllGroupsOpened && pFoundGroupItem->isClosed())
                         pFoundGroupItem->open(false);
                 return pFoundItem;
@@ -1895,5 +1895,5 @@
     foreach (UIGChooserItem *pItem, pParentItem->items(UIGChooserItemType_Group))
     {
-        QString strGroupDescriptor(pItem->toGroupItem()->opened() ? "go" : "gc");
+        QString strGroupDescriptor(pItem->toGroupItem()->isOpened() ? "go" : "gc");
         groups[strExtraDataKey] << QString("%1=%2").arg(strGroupDescriptor, pItem->name());
         gatherGroupOrders(groups, pItem);